/*
 * Copyright (C) 2006 - 2009
 * 
 * William van Hemert
 *
 * Thomas van Dijk
 * Jan-Pieter van den Heuvel
 * Wouter Slob
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

package libtw.reductions;

import libtw.input.GraphInput.InputData;
import libtw.ngraph.NVertex;

/**
 * The Class ReductionData is used as an extension to the InputData, since for
 * some rules its needed to mark the vertices that may not be altered anymore.
 * 
 * @author William van Hemert
 */
public class ReductionData<D extends InputData> {

	// original data of vertex
	public NVertex<D> original;
	
	// this boolean is used to mark vertices
	public boolean used;
	
	// converts the original data into the new data
	public ReductionData( NVertex<D> from ) {
		original = from;
		// set the default value
		used = false;
	}
	
	// returns the original name of the string 
	public String toString(){
		return original.data.name;
	}
}
