/*
 * Copyright (C) 2013
 * 
 * Stefan Fafianie
 *
 * This package is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This package is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * This package makes use of a selection of classes from the libtw library 
 * which is also published under the GNU Lesser General Public license.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this package; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 * 
 */

package order;

import java.util.BitSet;

import libtw.input.GraphInput.InputData;

/* Leaf node with no children.
 * This node returns a single partial solution */
public class LeafNode<D extends InputData> extends Node<D> {

	public LeafNode(BitSet subset, OrderDP<D> dp){
		super(subset, dp);
		this.subset = subset;
		reduce = false;
		checkUnique = false;
	}
	
	public PartialSolution applyNext() {
		hasNext = false;
		dp.operations++;
		return PartialSolution.leafSolution();
	}

	@Override
	public String toString() {
		return "leaf";
	}

}
