package steiner;

import java.util.HashMap;
import java.util.Set;

import libtw.algorithm.Constructive;
import libtw.algorithm.GreedyDegree;
import libtw.algorithm.PermutationToTreeDecomposition;
import libtw.input.GraphInput.InputData;
import libtw.input.InputException;
import libtw.ngraph.NGraph;
import libtw.ngraph.NTDBag;
import libtw.ngraph.NVertex;


public class Test {


	
	public static void main(String[] args) throws InputException {
		
		StpReader in;
		NGraph<InputData> g;	
		//in = new StpReader("F:/steinlib/sparse_complete_and_other_graphs/SP/antiwheel5.stp");
		in = new StpReader("F:/testset/testset/es80fst06.stp");
		g = in.get();
			
		Constructive<InputData> theAlgorithm = new PermutationToTreeDecomposition<InputData>( new GreedyDegree<InputData>() );
		theAlgorithm.setInput(g);
		theAlgorithm.run();
		NGraph<NTDBag<InputData>> td = theAlgorithm.getDecomposition();
		
		Set<NVertex<InputData>> terminals = in.getTerminals();
		NVertex<InputData> terminal = terminals.iterator().next();
		HashMap<Set<NVertex<InputData>>, Integer> weights = in.getWeights();
			
		TreeDecompositionToNiceTreeDecomposition<InputData> ntd = new TreeDecompositionToNiceTreeDecomposition<InputData>(terminal);
		ntd.setInput(td);
		ntd.run();		
		NGraph<NTDNiceBag<InputData>> niceDecomposition = ntd.getNiceDecomposition();
		
		RowDP<InputData> rowc = new RowDP<InputData>();
		SteinerTreeDP<InputData> rbc = new RankBasedSteinerTreeDP<InputData>();
		rbc.setInput(niceDecomposition, terminals, weights);
		rowc.setInput(niceDecomposition, terminals, weights);
		
		SteinerTreeDP<InputData> cdp = new SteinerTreeDP<InputData>();
		cdp.setInput(niceDecomposition, terminals, weights);
		
		RowDP<InputData> row = new RowDP<InputData>();
		row.setInput(niceDecomposition, terminals, weights);
		row.reduce = true;
		row.always = true;
		//stp.debug(true);
		
		long time = System.nanoTime();
		rowc.run();
		System.out.println((System.nanoTime()-time)/1000000);
				
		/*time = System.nanoTime();
		rbc.run();
		System.out.println(rbc.getSolution());
		System.out.println((System.nanoTime()-time)/1000000);
				
		/*time = System.nanoTime();
		cdp.run();
		System.out.println((System.nanoTime()-time)/1000000);
						
		time = System.nanoTime();
		row.run();
		System.out.println((System.nanoTime()-time)/1000000);*/
		
		
		
	}

}
